﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SASEBO
{
    class SASEBO_CMD_interface
    {
        ft245rl_interface ctrlif;
        public static int MAX_BUF = 8192;
        byte[] buf = new byte[MAX_BUF];
    
      //------------------------------------------------ Constructor
        public SASEBO_CMD_interface(ft245rl_interface ctrlif)
        {
            this.ctrlif = ctrlif;
            this.ctrlif.open();
        }

        // ----- Write short -----
        public void write_short(int addr, short dat)
        {
            buf[0] = (byte)0x01;
            buf[1] = (byte)((addr >> 8) & 0xFF);
            buf[2] = (byte)((addr) & 0xFF);
            buf[3] = (byte)((dat >> 8) & 0xFF);
            buf[4] = (byte)((dat) & 0xFF);
            ctrlif.write(buf, 5);
        }

        // ----- Read short -----
        public int read_short(int addr)
        {
            buf[0] = (byte)0x00;
            buf[1] = (byte)((addr >> 8) & 0xFF);
            buf[2] = (byte)((addr) & 0xFF);
            ctrlif.write(buf, 3);

            ctrlif.read(buf, 2);
            return ((int)buf[0] << 8) + (int)buf[1];
        }

        // ----- Burst write -----
        public void write_b(int addr, byte[] dat, int len)
        {
            for (int i = 0; i < len / 2; i++)
            {
                buf[i * 5 + 0] = (byte)0x01;
                buf[i * 5 + 1] = (byte)(((addr + i * 2) >> 8) & 0xFF);
                buf[i * 5 + 2] = (byte)(((addr + i * 2)) & 0xFF);
                buf[i * 5 + 3] = dat[i * 2];
                buf[i * 5 + 4] = dat[i * 2 + 1];
            }
            ctrlif.write(buf, 5 * (len / 2));
        }

        // ----- Burst read -----
        public void read_b(int addr, byte[] dat, int len)
        {
            for (int i = 0; i < len / 2; i++)
            {
                buf[i * 3 + 0] = (byte)0x00;
                buf[i * 3 + 1] = (byte)(((addr + i * 2) >> 8) & 0xFF);
                buf[i * 3 + 2] = (byte)(((addr + i * 2)) & 0xFF);
            }
            ctrlif.write(buf, 3 * (len / 2));
            ctrlif.read(dat, len);
        }
    }
}
