﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO.Ports;

using FTD2XX_NET;

namespace SASEBO
{
    interface ft245rl_interface
    {
        void open();
        void close();
        void write(byte[] dat, int len);
        void read(byte[] dat, int len);
    }

    class FT245RL : ft245rl_interface
    {
    FTDI ft245rlport = new FTDI();

    //------------------------------------------------ Constructor
    public FT245RL () {}

    //------------------------------------------------ open()
    public void open() {
      uint num_device = 0;

      ft245rlport.GetNumberOfDevices(ref num_device);
      Console.WriteLine("Number of FTDI devices : " + num_device);
      FTDI.FT_DEVICE_INFO_NODE[] device_list = new FTDI.FT_DEVICE_INFO_NODE[num_device];
      ft245rlport.GetDeviceList(device_list);
/*
      foreach (FTDI.FT_DEVICE_INFO_NODE device in device_list) {
        Console.WriteLine("--");
        Console.WriteLine("Flags  : " + device.Flags);
        Console.WriteLine("Type   : " + device.Type);
        Console.WriteLine("ID     : " + device.ID);
        Console.WriteLine("LocID  : " + device.LocId);
        Console.WriteLine("Serial : " + device.SerialNumber);
        Console.WriteLine("Info   : " + device.Description);
      }
*/
      ft245rlport.OpenByIndex(1);
        if (!ft245rlport.IsOpen) Console.WriteLine("Failed to open device.");
        else Console.WriteLine("Successfull to open device.");
      ft245rlport.ResetDevice();
   }

    //------------------------------------------------ close()
    public void close() {
      ft245rlport.Close();
    }

    //------------------------------------------------ write()
    public void write(byte[] dat, int len) {
      uint wlen = 0;
        ft245rlport.Write(dat, len, ref wlen);
    }
    
    //------------------------------------------------ read()
    public void read(byte[] dat, int len) {
      uint rlen = 0;
      ft245rlport.Read(dat, (uint)len, ref rlen);
    }
  }
}
